/*
 * This file is part of the Trezor project, https://trezor.io/
 *
 * Copyright (c) SatoshiLabs
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#pragma once

#include <stdbool.h>

// Initializes the Signals module
bool signals_init(void);

// INPUTS

// Checks if the TRZ is ready to communicate
bool signals_is_trz_ready(void);

// Checks if the device should stay in the bootloader
bool signals_is_stay_in_bootloader(void);

// OUTPUTS

// Signals that NRF firmware is running and initialized
void signals_nrf_ready(bool set);

// Sets the reserved output
void signals_reserved(bool set);

// Reads the current output setting
bool signals_out_get_nrf_ready(void);

// Reads the current output setting
bool signals_out_get_reserved(void);
